package com.gxwebsoft.cms.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.cms.service.CmsMpService;
import com.gxwebsoft.cms.entity.CmsMp;
import com.gxwebsoft.cms.param.CmsMpParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 小程序信息控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 20:47:57
 */
@Api(tags = "小程序信息管理")
@RestController
@RequestMapping("/api/cms/cms-mp")
public class CmsMpController extends BaseController {
    @Resource
    private CmsMpService cmsMpService;

    @ApiOperation("分页查询小程序信息")
    @GetMapping("/page")
    public ApiResult<PageResult<CmsMp>> page(CmsMpParam param) {
        // 使用关联查询
        return success(cmsMpService.pageRel(param));
    }

    @ApiOperation("查询全部小程序信息")
    @GetMapping()
    public ApiResult<List<CmsMp>> list(CmsMpParam param) {
        PageParam<CmsMp, CmsMpParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(cmsMpService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(cmsMpService.listRel(param));
    }

    @PreAuthorize("hasAuthority('cms:cmsMp:list')")
    @OperationLog
    @ApiOperation("根据id查询小程序信息")
    @GetMapping("/{id}")
    public ApiResult<CmsMp> get(@PathVariable("id") Integer id) {
        return success(cmsMpService.getById(id));
        // 使用关联查询
        //return success(cmsMpService.getByIdRel(id));
    }

    @ApiOperation("添加小程序信息")
    @PostMapping()
    public ApiResult<?> save(@RequestBody CmsMp cmsMp) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          cmsMp.setUserId(loginUser.getUserId());
        }
        if (cmsMpService.save(cmsMp)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改小程序信息")
    @PutMapping()
    public ApiResult<?> update(@RequestBody CmsMp cmsMp) {
        if (cmsMpService.updateById(cmsMp)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除小程序信息")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (cmsMpService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加小程序信息")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<CmsMp> list) {
        if (cmsMpService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改小程序信息")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<CmsMp> batchParam) {
        if (batchParam.update(cmsMpService, "mp_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除小程序信息")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (cmsMpService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
